/*ref: https://bkhome.org/news/202010/how-to-internationalize-any-c-program.html*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gstdio.h>

#include <libintl.h>
#include <locale.h>
#define  _(STRING) gettext(STRING)

GdkPixbuf *pw_pixbuf;
GError *gerror;

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data)
{
 //printf(_("Clicked on tray icon\n"));
 system("defaultpasswordmanager & ");
}

void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data)
{
 printf(_("Popup menu\n"));
}

static GtkStatusIcon *create_tray_icon() {
 GtkStatusIcon *tray_icon;
 
 tray_icon = gtk_status_icon_new();
 g_signal_connect(G_OBJECT(tray_icon), "activate", G_CALLBACK(tray_icon_on_click), NULL);
 //g_signal_connect(G_OBJECT(tray_icon), "popup-menu", G_CALLBACK(tray_icon_on_menu), NULL);
 
 pw_pixbuf=gdk_pixbuf_new_from_file("/usr/local/lib/X11/mini-icons/vault22.xpm", &gerror);
 gtk_status_icon_set_from_pixbuf(tray_icon,pw_pixbuf);

 gtk_status_icon_set_tooltip(tray_icon, _("Password Manager"));
 gtk_status_icon_set_visible(tray_icon, TRUE);

 return tray_icon;
}

int main(int argc, char **argv) {
 GtkStatusIcon *tray_icon;

 setlocale(LC_ALL, "");
 bindtextdomain("pw_tray", "/usr/share/locale");
 textdomain("pw_tray");
 
 gtk_init(&argc, &argv);
 tray_icon = create_tray_icon();
 gtk_main();

 return 0;
}
